package com.icesoft.support;

import java.io.Serializable;
import javax.faces.bean.CustomScoped;
import javax.faces.bean.ManagedBean;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import org.icefaces.ace.component.confirmationdialog.ConfirmationDialog;
import org.icefaces.util.JavaScriptRunner;

@ManagedBean
@CustomScoped(value = "#{window}")
public class TestBean implements Serializable {

    private int selectedIndex = 0;

    private boolean tabSwitchConfirmed = false;

    private ConfirmationDialog confirmationDialog = new ConfirmationDialog();

    private boolean fastTabs = true; // Add delay (large image, backend wait etc.) to tab loading make tabset difference clear

    public String getSlowDownTab() {
        try {
            Thread.sleep(2000);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "";
    }

    public void setSlowDownTab(String slowDownTab) {
    }

    public boolean isFastTabs() {
        return fastTabs;
    }

    public void setFastTabs(boolean fastTabs) {
        this.fastTabs = fastTabs;
    }

    public int getSelectedIndex() {
        return selectedIndex;
    }

    public void setSelectedIndex(int selectedIndex) {
        if (selectedIndex == 1 && !tabSwitchConfirmed) {
            FacesContext fc = FacesContext.getCurrentInstance();
            if (fc != null) {
                //JavascriptContext.addJavascriptCall(fc, " " + confirmationDialog.getWidgetVar() + ".show();");
                //JavascriptContext.addJavascriptCall(fc, "confirmDialog.show();");
                JavaScriptRunner.runScript(fc, "ice.ace.instance('iceForm:confirmDialog').show();");
            }
            tabSwitchConfirmed = false;
            return;
        }
        tabSwitchConfirmed = false;

        this.selectedIndex = selectedIndex;
    }

    public ConfirmationDialog getConfirmationDialog() {
        return confirmationDialog;
    }

    public void setConfirmationDialog(ConfirmationDialog confirmationDialog) {
        this.confirmationDialog = confirmationDialog;
    }

    public void confirm(ActionEvent event) {
        tabSwitchConfirmed = true;
        setSelectedIndex(1);
    }

    public void decline(ActionEvent event) {
        setSelectedIndex(0);
    }
}
